// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation
{
    /// <summary>
    /// Service operation for configurations.  (see
    /// http://aka.ms/azureautomationsdk/configurationoperations for more
    /// information)
    /// </summary>
    public partial interface IDscConfigurationOperations
    {
        /// <summary>
        /// Create the configuration identified by configuration name.  (see
        /// http://aka.ms/azureautomationsdk/configurationoperations for more
        /// information)
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// The automation account name.
        /// </param>
        /// <param name='parameters'>
        /// The create or update parameters for configuration.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the configuration create response.
        /// </returns>
        Task<DscConfigurationCreateOrUpdateResponse> CreateOrUpdateAsync(string resourceGroupName, string automationAccount, DscConfigurationCreateOrUpdateParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Retrieve the configuration identified by configuration name.  (see
        /// http://aka.ms/azureautomationsdk/configurationoperations for more
        /// information)
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// The automation account name.
        /// </param>
        /// <param name='configurationName'>
        /// The configuration name.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the get configuration operation.
        /// </returns>
        Task<DscConfigurationGetResponse> GetAsync(string resourceGroupName, string automationAccount, string configurationName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Retrieve the configuration script identified by configuration name.
        /// (see http://aka.ms/azureautomationsdk/configurationoperations for
        /// more information)
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// The automation account name.
        /// </param>
        /// <param name='configurationName'>
        /// The configuration name.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the get configuration operation.
        /// </returns>
        Task<DscConfigurationGetContentResponse> GetContentAsync(string resourceGroupName, string automationAccount, string configurationName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Retrieve a list of configurations.  (see
        /// http://aka.ms/azureautomationsdk/configurationoperations for more
        /// information)
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the resource group
        /// </param>
        /// <param name='automationAccount'>
        /// The automation account name.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the list configuration operation.
        /// </returns>
        Task<DscConfigurationListResponse> ListAsync(string resourceGroupName, string automationAccount, CancellationToken cancellationToken);
        
        /// <summary>
        /// Retrieve next list of configurations.  (see
        /// http://aka.ms/azureautomationsdk/configurationoperations for more
        /// information)
        /// </summary>
        /// <param name='nextLink'>
        /// The link to retrieve next set of items.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The response model for the list configuration operation.
        /// </returns>
        Task<DscConfigurationListResponse> ListNextAsync(string nextLink, CancellationToken cancellationToken);
    }
}
