// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// HDInsight activity properties.
    /// </summary>
    public partial class MapReduce : HDInsightActivityPropertiesBase
    {
        private string _className;
        
        /// <summary>
        /// Required. Class Name.
        /// </summary>
        public string ClassName
        {
            get { return this._className; }
            set { this._className = value; }
        }
        
        private IDictionary<string, string> _defines;
        
        /// <summary>
        /// Optional. Allows user to specify defines for mapreduce job request.
        /// </summary>
        public IDictionary<string, string> Defines
        {
            get { return this._defines; }
            set { this._defines = value; }
        }
        
        private IDictionary<string, string> _extendedProperties;
        
        /// <summary>
        /// Optional. User specified property bag. There is no restriction on
        /// the keys or values that can be used. These are passed as Defines
        /// in the mapreduce job request
        /// </summary>
        public IDictionary<string, string> ExtendedProperties
        {
            get { return this._extendedProperties; }
            set { this._extendedProperties = value; }
        }
        
        private string _jarFilePath;
        
        /// <summary>
        /// Required. Jar path.
        /// </summary>
        public string JarFilePath
        {
            get { return this._jarFilePath; }
            set { this._jarFilePath = value; }
        }
        
        private IList<string> _jarLibs;
        
        /// <summary>
        /// Optional. Jar libs.
        /// </summary>
        public IList<string> JarLibs
        {
            get { return this._jarLibs; }
            set { this._jarLibs = value; }
        }
        
        private string _jarLinkedService;
        
        /// <summary>
        /// Optional. Jar linked service.
        /// </summary>
        public string JarLinkedService
        {
            get { return this._jarLinkedService; }
            set { this._jarLinkedService = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MapReduce class.
        /// </summary>
        public MapReduce()
        {
            this.Defines = new LazyDictionary<string, string>();
            this.ExtendedProperties = new LazyDictionary<string, string>();
            this.JarLibs = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the MapReduce class with required
        /// arguments.
        /// </summary>
        public MapReduce(string className, string jarFilePath)
            : this()
        {
            if (className == null)
            {
                throw new ArgumentNullException("className");
            }
            if (jarFilePath == null)
            {
                throw new ArgumentNullException("jarFilePath");
            }
            this.ClassName = className;
            this.JarFilePath = jarFilePath;
        }
    }
}
