// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// Linked Service for Teradata data source.
    /// </summary>
    public partial class OnPremisesHdfsLinkedService : LinkedServiceProperties
    {
        private string _authenticationType;
        
        /// <summary>
        /// Required. Gets or sets authenticationType to be used for connection.
        /// </summary>
        public string AuthenticationType
        {
            get { return this._authenticationType; }
            set { this._authenticationType = value; }
        }
        
        private string _contentType;
        
        /// <summary>
        /// Optional. Gets or sets hint to content type
        /// </summary>
        public string ContentType
        {
            get { return this._contentType; }
            set { this._contentType = value; }
        }
        
        private string _encryptedCredential;
        
        /// <summary>
        /// Optional. Gets or sets the encryptedCredential for authentication.
        /// </summary>
        public string EncryptedCredential
        {
            get { return this._encryptedCredential; }
            set { this._encryptedCredential = value; }
        }
        
        private string _gatewayName;
        
        /// <summary>
        /// Required. Gets or sets the on-premises gateway name.
        /// </summary>
        public string GatewayName
        {
            get { return this._gatewayName; }
            set { this._gatewayName = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Optional. Gets or sets password for authentication.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _url;
        
        /// <summary>
        /// Required. Gets or sets HDFS url.
        /// </summary>
        public string Url
        {
            get { return this._url; }
            set { this._url = value; }
        }
        
        private string _username;
        
        /// <summary>
        /// Optional. Gets or sets username for authentication.
        /// </summary>
        public string Username
        {
            get { return this._username; }
            set { this._username = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the OnPremisesHdfsLinkedService class.
        /// </summary>
        public OnPremisesHdfsLinkedService()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the OnPremisesHdfsLinkedService class
        /// with required arguments.
        /// </summary>
        public OnPremisesHdfsLinkedService(string url, string authenticationType, string gatewayName)
            : this()
        {
            if (url == null)
            {
                throw new ArgumentNullException("url");
            }
            if (authenticationType == null)
            {
                throw new ArgumentNullException("authenticationType");
            }
            if (gatewayName == null)
            {
                throw new ArgumentNullException("gatewayName");
            }
            this.Url = url;
            this.AuthenticationType = authenticationType;
            this.GatewayName = gatewayName;
        }
    }
}
