// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Insights;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights
{
    public static partial class StorageDiagnosticSettingsOperationsExtensions
    {
        /// <summary>
        /// Gets the diagnostic settings for the specified storage service.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IStorageDiagnosticSettingsOperations.
        /// </param>
        /// <param name='resourceUri'>
        /// Required. The resource identifier of the storage service.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static StorageDiagnosticSettingsGetResponse Get(this IStorageDiagnosticSettingsOperations operations, string resourceUri)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IStorageDiagnosticSettingsOperations)s).GetAsync(resourceUri);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Gets the diagnostic settings for the specified storage service.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IStorageDiagnosticSettingsOperations.
        /// </param>
        /// <param name='resourceUri'>
        /// Required. The resource identifier of the storage service.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<StorageDiagnosticSettingsGetResponse> GetAsync(this IStorageDiagnosticSettingsOperations operations, string resourceUri)
        {
            return operations.GetAsync(resourceUri, CancellationToken.None);
        }
        
        /// <summary>
        /// Creates or update the diagnostic settings for the specified storage
        /// service.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IStorageDiagnosticSettingsOperations.
        /// </param>
        /// <param name='resourceUri'>
        /// Required. The resource identifier of the storage service.
        /// </param>
        /// <param name='parameters'>
        /// Required. The storage diagnostic settings parameters.
        /// </param>
        /// <returns>
        /// Generic empty response. We only pass it to ensure json error
        /// handling
        /// </returns>
        public static EmptyResponse Put(this IStorageDiagnosticSettingsOperations operations, string resourceUri, StorageDiagnosticSettingsPutParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IStorageDiagnosticSettingsOperations)s).PutAsync(resourceUri, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Creates or update the diagnostic settings for the specified storage
        /// service.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IStorageDiagnosticSettingsOperations.
        /// </param>
        /// <param name='resourceUri'>
        /// Required. The resource identifier of the storage service.
        /// </param>
        /// <param name='parameters'>
        /// Required. The storage diagnostic settings parameters.
        /// </param>
        /// <returns>
        /// Generic empty response. We only pass it to ensure json error
        /// handling
        /// </returns>
        public static Task<EmptyResponse> PutAsync(this IStorageDiagnosticSettingsOperations operations, string resourceUri, StorageDiagnosticSettingsPutParameters parameters)
        {
            return operations.PutAsync(resourceUri, parameters, CancellationToken.None);
        }
    }
}
