// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resources.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Management lock information.
    /// </summary>
    public partial class ManagementLockObject : IResource
    {
        /// <summary>
        /// Initializes a new instance of the ManagementLockObject class.
        /// </summary>
        public ManagementLockObject() { }

        /// <summary>
        /// Initializes a new instance of the ManagementLockObject class.
        /// </summary>
        public ManagementLockObject(string id = default(string), string type = default(string), string name = default(string), string level = default(string), string notes = default(string))
        {
            Id = id;
            Type = type;
            Name = name;
            Level = level;
            Notes = notes;
        }

        /// <summary>
        /// Gets or sets the Id of the lock.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the type of the lock.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the name of the lock.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the lock level of the management lock. Possible
        /// values for this property include: 'NotSpecified', 'CanNotDelete',
        /// 'ReadOnly'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.level")]
        public string Level { get; set; }

        /// <summary>
        /// Gets or sets the notes of the management lock.
        /// </summary>
        [JsonProperty(PropertyName = "properties.notes")]
        public string Notes { get; set; }

    }
}
