// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// Details of a RemoteApp active directory configuration.
    /// </summary>
    public partial class ActiveDirectoryConfig
    {
        private string _domainName;
        
        /// <summary>
        /// Required. The name of the on-premise domain to join the RD Session
        /// Host servers to.
        /// </summary>
        public string DomainName
        {
            get { return this._domainName; }
            set { this._domainName = value; }
        }
        
        private string _organizationalUnit;
        
        /// <summary>
        /// Optional. The name of your organizational unit to join the RD
        /// Session Host servers, e.g.
        /// OU=MyOu,DC=MyDomain,DC=ParentDomain,DC=com. Attributes such as OU,
        /// DC, etc. must be in uppercase.
        /// </summary>
        public string OrganizationalUnit
        {
            get { return this._organizationalUnit; }
            set { this._organizationalUnit = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Required. The service account's password.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Required. The user name of a service account that has permission to
        /// add computers to the domain.The username must be specified in the
        /// UPN or down-level logon name format (user@some.domain or
        /// some.domain\\user).
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ActiveDirectoryConfig class.
        /// </summary>
        public ActiveDirectoryConfig()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ActiveDirectoryConfig class with
        /// required arguments.
        /// </summary>
        public ActiveDirectoryConfig(string domainName, string userName, string password)
            : this()
        {
            if (domainName == null)
            {
                throw new ArgumentNullException("domainName");
            }
            if (userName == null)
            {
                throw new ArgumentNullException("userName");
            }
            if (password == null)
            {
                throw new ArgumentNullException("password");
            }
            this.DomainName = domainName;
            this.UserName = userName;
            this.Password = password;
        }
    }
}
