// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Scheduler.Models;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Client certification authentication for job
    /// </summary>
    public partial class ClientCertAuthentication : HttpAuthentication
    {
        private System.DateTime? _certificateExpiration;
        
        /// <summary>
        /// Optional. Gets or sets the certificate expiration.
        /// </summary>
        public System.DateTime? CertificateExpiration
        {
            get { return this._certificateExpiration; }
            set { this._certificateExpiration = value; }
        }
        
        private string _certificateSubjectName;
        
        /// <summary>
        /// Optional. Gets or sets the certificate subjectname.
        /// </summary>
        public string CertificateSubjectName
        {
            get { return this._certificateSubjectName; }
            set { this._certificateSubjectName = value; }
        }
        
        private string _certificateThumbprint;
        
        /// <summary>
        /// Optional. Gets or sets the certificate thumbprint.
        /// </summary>
        public string CertificateThumbprint
        {
            get { return this._certificateThumbprint; }
            set { this._certificateThumbprint = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Optional. Gets or sets the password.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _pfx;
        
        /// <summary>
        /// Optional. Gets or sets the pfx.
        /// </summary>
        public string Pfx
        {
            get { return this._pfx; }
            set { this._pfx = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ClientCertAuthentication class.
        /// </summary>
        public ClientCertAuthentication()
        {
        }
    }
}
