// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.SiteRecovery.Models;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a Protection Container object.
    /// </summary>
    public partial class ProtectionContainer : ServiceResourceBase
    {
        private IList<ProtectionProfile> _availableProtectionProfiles;
        
        /// <summary>
        /// Required. AvailableProtectionProfiles of protection container.
        /// </summary>
        public IList<ProtectionProfile> AvailableProtectionProfiles
        {
            get { return this._availableProtectionProfiles; }
            set { this._availableProtectionProfiles = value; }
        }
        
        private string _fabricObjectId;
        
        /// <summary>
        /// Required. FabricObjectId of the protection container.
        /// </summary>
        public string FabricObjectId
        {
            get { return this._fabricObjectId; }
            set { this._fabricObjectId = value; }
        }
        
        private string _fabricType;
        
        /// <summary>
        /// Required. FabricType of protection container.
        /// </summary>
        public string FabricType
        {
            get { return this._fabricType; }
            set { this._fabricType = value; }
        }
        
        private string _role;
        
        /// <summary>
        /// Required. Role of protection container.
        /// </summary>
        public string Role
        {
            get { return this._role; }
            set { this._role = value; }
        }
        
        private string _serverId;
        
        /// <summary>
        /// Required. ID of the parent server
        /// </summary>
        public string ServerId
        {
            get { return this._serverId; }
            set { this._serverId = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Required. Type of protection container.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectionContainer class.
        /// </summary>
        public ProtectionContainer()
        {
            this.AvailableProtectionProfiles = new LazyList<ProtectionProfile>();
        }
    }
}
