// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Net.Http;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.SiteRecovery;
using Microsoft.WindowsAzure.Management.SiteRecovery.Models;

namespace Microsoft.WindowsAzure.Management.SiteRecovery
{
    public partial class SiteRecoveryManagementClient : ServiceClient<SiteRecoveryManagementClient>, ISiteRecoveryManagementClient
    {
        private string _apiVersion;
        
        /// <summary>
        /// Gets the API version.
        /// </summary>
        public string ApiVersion
        {
            get { return this._apiVersion; }
        }
        
        private Uri _baseUri;
        
        /// <summary>
        /// Gets the URI used as the base for all cloud service requests.
        /// </summary>
        public Uri BaseUri
        {
            get { return this._baseUri; }
        }
        
        private string _cloudServiceName;
        
        public string CloudServiceName
        {
            get { return this._cloudServiceName; }
            set { this._cloudServiceName = value; }
        }
        
        private SubscriptionCloudCredentials _credentials;
        
        /// <summary>
        /// Gets subscription credentials which uniquely identify Microsoft
        /// Azure subscription. The subscription ID forms part of the URI for
        /// every service call.
        /// </summary>
        public SubscriptionCloudCredentials Credentials
        {
            get { return this._credentials; }
        }
        
        private int _longRunningOperationInitialTimeout;
        
        /// <summary>
        /// Gets or sets the initial timeout for Long Running Operations.
        /// </summary>
        public int LongRunningOperationInitialTimeout
        {
            get { return this._longRunningOperationInitialTimeout; }
            set { this._longRunningOperationInitialTimeout = value; }
        }
        
        private int _longRunningOperationRetryTimeout;
        
        /// <summary>
        /// Gets or sets the retry timeout for Long Running Operations.
        /// </summary>
        public int LongRunningOperationRetryTimeout
        {
            get { return this._longRunningOperationRetryTimeout; }
            set { this._longRunningOperationRetryTimeout = value; }
        }
        
        private string _resourceName;
        
        public string ResourceName
        {
            get { return this._resourceName; }
            set { this._resourceName = value; }
        }
        
        private IJobOperations _jobs;
        
        /// <summary>
        /// Definition for Job Operations.
        /// </summary>
        public virtual IJobOperations Jobs
        {
            get { return this._jobs; }
        }
        
        private INetworkMappingOperations _networkMappings;
        
        /// <summary>
        /// Definition of network mapping operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual INetworkMappingOperations NetworkMappings
        {
            get { return this._networkMappings; }
        }
        
        private INetworkOperations _networks;
        
        /// <summary>
        /// Definition of network operations for the Site Recovery extension.
        /// </summary>
        public virtual INetworkOperations Networks
        {
            get { return this._networks; }
        }
        
        private IProtectionContainerOperations _protectionContainer;
        
        /// <summary>
        /// Definition of Protection Container operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IProtectionContainerOperations ProtectionContainer
        {
            get { return this._protectionContainer; }
        }
        
        private IProtectionEntityOperations _protectionEntity;
        
        /// <summary>
        /// Definition of protection entity operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IProtectionEntityOperations ProtectionEntity
        {
            get { return this._protectionEntity; }
        }
        
        private IProtectionProfileOperations _protectionProfile;
        
        /// <summary>
        /// Definition of Protection Profile operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IProtectionProfileOperations ProtectionProfile
        {
            get { return this._protectionProfile; }
        }
        
        private IRecoveryPlanOperations _recoveryPlan;
        
        /// <summary>
        /// Definition of recoveryplan operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IRecoveryPlanOperations RecoveryPlan
        {
            get { return this._recoveryPlan; }
        }
        
        private IServerOperations _servers;
        
        /// <summary>
        /// Definition of server operations for the Site Recovery extension.
        /// </summary>
        public virtual IServerOperations Servers
        {
            get { return this._servers; }
        }
        
        private ISiteOperations _sites;
        
        /// <summary>
        /// Definition of Site operations for the Site Recovery extension.
        /// </summary>
        public virtual ISiteOperations Sites
        {
            get { return this._sites; }
        }
        
        private IStorageMappingOperations _storageMappings;
        
        /// <summary>
        /// Definition of storage mapping operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IStorageMappingOperations StorageMappings
        {
            get { return this._storageMappings; }
        }
        
        private IStorageOperations _storages;
        
        /// <summary>
        /// Definition of storage operations for the Site Recovery extension.
        /// </summary>
        public virtual IStorageOperations Storages
        {
            get { return this._storages; }
        }
        
        private IStoragePoolMappingOperations _storagePoolMappings;
        
        /// <summary>
        /// Definition of storage pool mapping operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IStoragePoolMappingOperations StoragePoolMappings
        {
            get { return this._storagePoolMappings; }
        }
        
        private IVaultExtendedInfoOperations _vaultExtendedInfo;
        
        /// <summary>
        /// Definition of vault extended info operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IVaultExtendedInfoOperations VaultExtendedInfo
        {
            get { return this._vaultExtendedInfo; }
        }
        
        private IVirtualMachineGroupOperations _vmGroup;
        
        /// <summary>
        /// Definition of virtual machine operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IVirtualMachineGroupOperations VmGroup
        {
            get { return this._vmGroup; }
        }
        
        private IVirtualMachineOperations _vm;
        
        /// <summary>
        /// Definition of virtual machine operations for the Site Recovery
        /// extension.
        /// </summary>
        public virtual IVirtualMachineOperations Vm
        {
            get { return this._vm; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteRecoveryManagementClient
        /// class.
        /// </summary>
        public SiteRecoveryManagementClient()
            : base()
        {
            this._jobs = new JobOperations(this);
            this._networkMappings = new NetworkMappingOperations(this);
            this._networks = new NetworkOperations(this);
            this._protectionContainer = new ProtectionContainerOperations(this);
            this._protectionEntity = new ProtectionEntityOperations(this);
            this._protectionProfile = new ProtectionProfileOperations(this);
            this._recoveryPlan = new RecoveryPlanOperations(this);
            this._servers = new ServerOperations(this);
            this._sites = new SiteOperations(this);
            this._storageMappings = new StorageMappingOperations(this);
            this._storages = new StorageOperations(this);
            this._storagePoolMappings = new StoragePoolMappingOperations(this);
            this._vaultExtendedInfo = new VaultExtendedInfoOperations(this);
            this._vmGroup = new VirtualMachineGroupOperations(this);
            this._vm = new VirtualMachineOperations(this);
            this._apiVersion = "2013-03-01";
            this._longRunningOperationInitialTimeout = -1;
            this._longRunningOperationRetryTimeout = -1;
            this.HttpClient.Timeout = TimeSpan.FromSeconds(300);
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteRecoveryManagementClient
        /// class.
        /// </summary>
        /// <param name='cloudServiceName'>
        /// Required.
        /// </param>
        /// <param name='resourceName'>
        /// Required.
        /// </param>
        /// <param name='credentials'>
        /// Required. Gets subscription credentials which uniquely identify
        /// Microsoft Azure subscription. The subscription ID forms part of
        /// the URI for every service call.
        /// </param>
        /// <param name='baseUri'>
        /// Optional. Gets the URI used as the base for all cloud service
        /// requests.
        /// </param>
        public SiteRecoveryManagementClient(string cloudServiceName, string resourceName, SubscriptionCloudCredentials credentials, Uri baseUri)
            : this()
        {
            if (cloudServiceName == null)
            {
                throw new ArgumentNullException("cloudServiceName");
            }
            if (resourceName == null)
            {
                throw new ArgumentNullException("resourceName");
            }
            if (credentials == null)
            {
                throw new ArgumentNullException("credentials");
            }
            if (baseUri == null)
            {
                throw new ArgumentNullException("baseUri");
            }
            this._cloudServiceName = cloudServiceName;
            this._resourceName = resourceName;
            this._credentials = credentials;
            this._baseUri = baseUri;
            
            this.Credentials.InitializeServiceClient(this);
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteRecoveryManagementClient
        /// class.
        /// </summary>
        /// <param name='cloudServiceName'>
        /// Required.
        /// </param>
        /// <param name='resourceName'>
        /// Required.
        /// </param>
        /// <param name='credentials'>
        /// Required. Gets subscription credentials which uniquely identify
        /// Microsoft Azure subscription. The subscription ID forms part of
        /// the URI for every service call.
        /// </param>
        public SiteRecoveryManagementClient(string cloudServiceName, string resourceName, SubscriptionCloudCredentials credentials)
            : this()
        {
            if (cloudServiceName == null)
            {
                throw new ArgumentNullException("cloudServiceName");
            }
            if (resourceName == null)
            {
                throw new ArgumentNullException("resourceName");
            }
            if (credentials == null)
            {
                throw new ArgumentNullException("credentials");
            }
            this._cloudServiceName = cloudServiceName;
            this._resourceName = resourceName;
            this._credentials = credentials;
            this._baseUri = new Uri("https://management.core.windows.net");
            
            this.Credentials.InitializeServiceClient(this);
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteRecoveryManagementClient
        /// class.
        /// </summary>
        /// <param name='httpClient'>
        /// The Http client
        /// </param>
        public SiteRecoveryManagementClient(HttpClient httpClient)
            : base(httpClient)
        {
            this._jobs = new JobOperations(this);
            this._networkMappings = new NetworkMappingOperations(this);
            this._networks = new NetworkOperations(this);
            this._protectionContainer = new ProtectionContainerOperations(this);
            this._protectionEntity = new ProtectionEntityOperations(this);
            this._protectionProfile = new ProtectionProfileOperations(this);
            this._recoveryPlan = new RecoveryPlanOperations(this);
            this._servers = new ServerOperations(this);
            this._sites = new SiteOperations(this);
            this._storageMappings = new StorageMappingOperations(this);
            this._storages = new StorageOperations(this);
            this._storagePoolMappings = new StoragePoolMappingOperations(this);
            this._vaultExtendedInfo = new VaultExtendedInfoOperations(this);
            this._vmGroup = new VirtualMachineGroupOperations(this);
            this._vm = new VirtualMachineOperations(this);
            this._apiVersion = "2013-03-01";
            this._longRunningOperationInitialTimeout = -1;
            this._longRunningOperationRetryTimeout = -1;
            this.HttpClient.Timeout = TimeSpan.FromSeconds(300);
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteRecoveryManagementClient
        /// class.
        /// </summary>
        /// <param name='cloudServiceName'>
        /// Required.
        /// </param>
        /// <param name='resourceName'>
        /// Required.
        /// </param>
        /// <param name='credentials'>
        /// Required. Gets subscription credentials which uniquely identify
        /// Microsoft Azure subscription. The subscription ID forms part of
        /// the URI for every service call.
        /// </param>
        /// <param name='baseUri'>
        /// Optional. Gets the URI used as the base for all cloud service
        /// requests.
        /// </param>
        /// <param name='httpClient'>
        /// The Http client
        /// </param>
        public SiteRecoveryManagementClient(string cloudServiceName, string resourceName, SubscriptionCloudCredentials credentials, Uri baseUri, HttpClient httpClient)
            : this(httpClient)
        {
            if (cloudServiceName == null)
            {
                throw new ArgumentNullException("cloudServiceName");
            }
            if (resourceName == null)
            {
                throw new ArgumentNullException("resourceName");
            }
            if (credentials == null)
            {
                throw new ArgumentNullException("credentials");
            }
            if (baseUri == null)
            {
                throw new ArgumentNullException("baseUri");
            }
            this._cloudServiceName = cloudServiceName;
            this._resourceName = resourceName;
            this._credentials = credentials;
            this._baseUri = baseUri;
            
            this.Credentials.InitializeServiceClient(this);
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteRecoveryManagementClient
        /// class.
        /// </summary>
        /// <param name='cloudServiceName'>
        /// Required.
        /// </param>
        /// <param name='resourceName'>
        /// Required.
        /// </param>
        /// <param name='credentials'>
        /// Required. Gets subscription credentials which uniquely identify
        /// Microsoft Azure subscription. The subscription ID forms part of
        /// the URI for every service call.
        /// </param>
        /// <param name='httpClient'>
        /// The Http client
        /// </param>
        public SiteRecoveryManagementClient(string cloudServiceName, string resourceName, SubscriptionCloudCredentials credentials, HttpClient httpClient)
            : this(httpClient)
        {
            if (cloudServiceName == null)
            {
                throw new ArgumentNullException("cloudServiceName");
            }
            if (resourceName == null)
            {
                throw new ArgumentNullException("resourceName");
            }
            if (credentials == null)
            {
                throw new ArgumentNullException("credentials");
            }
            this._cloudServiceName = cloudServiceName;
            this._resourceName = resourceName;
            this._credentials = credentials;
            this._baseUri = new Uri("https://management.core.windows.net");
            
            this.Credentials.InitializeServiceClient(this);
        }
        
        /// <summary>
        /// Clones properties from current instance to another
        /// SiteRecoveryManagementClient instance
        /// </summary>
        /// <param name='client'>
        /// Instance of SiteRecoveryManagementClient to clone to
        /// </param>
        protected override void Clone(ServiceClient<SiteRecoveryManagementClient> client)
        {
            base.Clone(client);
            
            if (client is SiteRecoveryManagementClient)
            {
                SiteRecoveryManagementClient clonedClient = ((SiteRecoveryManagementClient)client);
                
                clonedClient._cloudServiceName = this._cloudServiceName;
                clonedClient._resourceName = this._resourceName;
                clonedClient._credentials = this._credentials;
                clonedClient._baseUri = this._baseUri;
                clonedClient._apiVersion = this._apiVersion;
                clonedClient._longRunningOperationInitialTimeout = this._longRunningOperationInitialTimeout;
                clonedClient._longRunningOperationRetryTimeout = this._longRunningOperationRetryTimeout;
                
                clonedClient.Credentials.InitializeServiceClient(clonedClient);
            }
        }
        
        /// <summary>
        /// Parse enum values for type LocalNetworkConnectionType.
        /// </summary>
        /// <param name='value'>
        /// The value to parse.
        /// </param>
        /// <returns>
        /// The enum value.
        /// </returns>
        internal static LocalNetworkConnectionType ParseLocalNetworkConnectionType(string value)
        {
            if ("IPsec".Equals(value, StringComparison.OrdinalIgnoreCase))
            {
                return LocalNetworkConnectionType.IPSecurity;
            }
            if ("Dedicated".Equals(value, StringComparison.OrdinalIgnoreCase))
            {
                return LocalNetworkConnectionType.Dedicated;
            }
            throw new ArgumentOutOfRangeException("value");
        }
        
        /// <summary>
        /// Convert an enum of type LocalNetworkConnectionType to a string.
        /// </summary>
        /// <param name='value'>
        /// The value to convert to a string.
        /// </param>
        /// <returns>
        /// The enum value as a string.
        /// </returns>
        internal static string LocalNetworkConnectionTypeToString(LocalNetworkConnectionType value)
        {
            if (value == LocalNetworkConnectionType.IPSecurity)
            {
                return "IPsec";
            }
            if (value == LocalNetworkConnectionType.Dedicated)
            {
                return "Dedicated";
            }
            throw new ArgumentOutOfRangeException("value");
        }
    }
}
