// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.WindowsAzure.WebSitesExtensions;
using Microsoft.WindowsAzure.WebSitesExtensions.Models;

namespace Microsoft.WindowsAzure.WebSitesExtensions
{
    /// <summary>
    /// The websites extensions client manages the web sites deployments, web
    /// jobs and other extensions.
    /// </summary>
    public static partial class DiagnosticOperationsExtensions
    {
        /// <summary>
        /// Get diagnostics settings.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.WebSitesExtensions.IDiagnosticOperations.
        /// </param>
        /// <returns>
        /// The get diagnostic settings operation response.
        /// </returns>
        public static DiagnosticGetResponse GetSettings(this IDiagnosticOperations operations)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDiagnosticOperations)s).GetSettingsAsync();
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Get diagnostics settings.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.WebSitesExtensions.IDiagnosticOperations.
        /// </param>
        /// <returns>
        /// The get diagnostic settings operation response.
        /// </returns>
        public static Task<DiagnosticGetResponse> GetSettingsAsync(this IDiagnosticOperations operations)
        {
            return operations.GetSettingsAsync(CancellationToken.None);
        }
        
        /// <summary>
        /// Update diagnostics settings.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.WebSitesExtensions.IDiagnosticOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. The diagnostics setting information new values.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse UpdateSettings(this IDiagnosticOperations operations, DiagnosticUpdateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDiagnosticOperations)s).UpdateSettingsAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Update diagnostics settings.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.WebSitesExtensions.IDiagnosticOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. The diagnostics setting information new values.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> UpdateSettingsAsync(this IDiagnosticOperations operations, DiagnosticUpdateParameters parameters)
        {
            return operations.UpdateSettingsAsync(parameters, CancellationToken.None);
        }
    }
}
